/* $Id: definitions.h,v 1.4 2005/07/18 18:15:40 bedlam Exp $ */
/* definitions.h
 * - All declarations and defines for ices
 * Copyright (c) 2000 Alexander Havng
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */

#ifndef _STREAM404_DEFINITIONS_H
#define _STREAM404_DEFINITIONS_H

#ifdef _WIN32
# include <win32config.h>
#else
# ifdef HAVE_CONFIG_H
#  include <config.h>
# endif
#endif

#ifndef __USE_MISC
# define __USE_MISC
#endif

#ifndef __USE_GNU
# define __USE_GNU
#endif

#ifndef __USE_BSD
# define __USE_BSD
#endif

#ifndef __EXTENSIONS__
# define __EXTENSIONS__
#endif

#ifndef _GNU_SOURCE
# define _GNU_SOURCE
#endif

#ifndef __USE_POSIX
# define __USE_POSIX
#endif

#include <stdio.h>
#include <stdarg.h>
#include <math.h>
#include <unistd.h>
#include <assert.h>
#ifdef HAVE_SHOUT_SHOUT_H
# include <shout/shout.h>
#else
# include <shout.h>
#endif
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <vorbis/vorbisfile.h>

#ifdef HAVE_ERRNO_H
#include <errno.h>
#endif

#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif

#ifdef HAVE_SYS_TYPES_H
#include <sys/types.h>
#endif

#ifdef HAVE_SYS_STAT_H
#include <sys/stat.h>
#endif

#ifdef HAVE_FCNTL_H
#include <fcntl.h>
#endif

/* This has all the datatypes */
#include "stream404types.h"

#include "setup.h"
#include "stream.h"
#include "log.h"
#include "util.h"
#include "cue.h"
#include "id3.h"
#include "mp3.h"
#include "signals.h"
#include "reencode.h"
#include "in_vorbis.h"
#include "http.h"
#include "stream404_config.h"
#include "playlist/playlist.h"
#include "playlist/sql_builtin.h"

stream404_plugin_t *crossfade_plugin(int secs, int minsecs);


#define BUFSIZE 8192
#define STREAM404_DEFAULT_HOST "127.0.0.1"
#define STREAM404_DEFAULT_PORT 8000
#define STREAM404_DEFAULT_MOUNT "/stream404"
#define STREAM404_DEFAULT_PASSWORD "letmein"
#define STREAM404_DEFAULT_PROTOCOL http_protocol_e
#define STREAM404_DEFAULT_NAME "Default stream name"
#define STREAM404_DEFAULT_GENRE "Default genre"
#define STREAM404_DEFAULT_DESCRIPTION "Default description"
#define STREAM404_DEFAULT_URL "http://www.icecast.org/"
#define STREAM404_DEFAULT_BITRATE 128
#define STREAM404_DEFAULT_QUALITY -1
#define STREAM404_DEFAULT_ISPUBLIC 1
#define STREAM404_DEFAULT_MODULE "stream404"
#define STREAM404_DEFAULT_CONFIGFILE "stream404.conf"
#define STREAM404_DEFAULT_PLAYLIST_FILE "playlist.txt"
#define STREAM404_DEFAULT_RANDOMIZE_PLAYLIST 0
#define STREAM404_DEFAULT_DAEMON 0
#define STREAM404_DEFAULT_BASE_DIRECTORY "/tmp"
#define STREAM404_DEFAULT_PLAYLIST_TYPE stream404_playlist_builtin_e;
#define STREAM404_DEFAULT_VERBOSE 0
#define STREAM404_DEFAULT_REENCODE 0
#define STREAM404_DEFAULT_OUTPUT_TYPE STREAM404_OUTPUT_MP3

#define STREAM404_DEFAULT_SQL_PORT 3306
#define STREAM404_DEFAULT_SQL_USOCKET "/var/run/mysqld/mysqld.sock"
#define STREAM404_DEFAULT_SQL_SQLTYPE "MYSQL"
#define STREAM404_DEFAULT_SQL_USER "user"
#define STREAM404_DEFAULT_SQL_PASSWORD "password"
#define STREAM404_DEFAULT_SQL_DATABASE "mediabox404"
#define STREAM404_DEFAULT_SQL_TABLE "t_streamstack"
#define STREAM404_DEFAULT_SQL_URGTABLE "t_pilotstack"
#define STREAM404_DEFAULT_SQL_CURRENTSTREAMTABLE "t_currentstream"
#define STREAM404_DEFAULT_SQL_STREAMLOGTABLE "t_streamlog"
#define STREAM404_DEFAULT_SQL_METADATATABLE "t_metadata"

#ifndef ALLOW_COREDUMPS
#define ALLOW_COREDUMPS 1
#endif


#endif
